// Llibreria per a la particula

const int RADI_MINIM_ATRACCIO = 0; //La distancia minima a la que comensa l'atraccio


//Creem particula
class Particula {
    private:	
	vector posicio, v; //posicio, velocitat
	int PARTICULA_AMPLADA, PARTICULA_ALTURA; //dimensions particula
	unsigned long long massa; // massa

    public:
	
	Particula(); //constructor
		
	void valors( double posx, double posy, double velx, double vely, unsigned long long massaentrada, float diametre ); // Funcio per modificar valors
	
	void entrada(); // Funcio per detectar les tecles que modifiquen els valors
	
	void moviment(); // funcio per aplicar el moviment
	
	void atraccio( vector pos, unsigned long long massa2); //funcio per a la atraccio entre particules
	
	void imprimir( vector PuntReferencia, float Zoom); // fiuncio per imprimir a pantalla la particula
	
	vector retornarposicio();
	
	unsigned long long retornarmassa();
	

};


Particula::Particula() // constructor
{

    v.x = v.y = 0;
    
}


//funcio per modificar els valors de les particules
void Particula::valors( double posx, double posy, double velx, double vely, unsigned long long massaentrada, float diametre )
{    
    posicio.x = posx;
    posicio.y = posy;
    
    v.x = velx;
    v.y = vely;

    massa = massaentrada;
    
    PARTICULA_AMPLADA = PARTICULA_ALTURA = diametre;
}

void Particula::entrada()
{

    //si es prem una tecla...
    if( event.type == SDL_KEYDOWN )
    {
	switch( event.key.keysym.sym )//depenent de la tecla es fa una cosa o una altre
	{
	    case SDLK_s: v.x = 0, v.y = 0; break; //parar les particules		
	}
	
    }
}

//retornar posicio
vector Particula::retornarposicio()
{
    return posicio;
}

//retornar massa
unsigned long long Particula::retornarmassa()
{
    return massa;
}

//funcio moviment
void Particula::moviment()
{
    SumaVectors( posicio, MultiplicacioVectors( v, (TempsPerCicle * FactorVelocitat)) ); // es mou la posicio sumantli la velocitat

}

//atraccio entre particules
void Particula::atraccio( vector posicio2, unsigned long long massa2 )
{
    if ( ModulVector ( DistanciaVectors ( posicio, posicio2 )) > RADI_MINIM_ATRACCIO )
    {
	if ( repulsio == false ) //atraccio
	{
	    SumaVectors( v, MultiplicacioVectors ( AtraccioVectors( posicio, posicio2, massa2 ), (TempsPerCicle * FactorVelocitat)));
	}
	else //repulsio
	{
	    RestaVectors( v, MultiplicacioVectors ( AtraccioVectors( posicio, posicio2, massa2 ), (TempsPerCicle * FactorVelocitat)));
	}
    }
}

void Particula::imprimir( vector PuntReferencia, float Zoom)
{
    //simprimeix
    SDL_Rect ImatgeParticula;
    ImatgeParticula.x = (PuntReferencia.x + (posicio.x * Zoom));
    ImatgeParticula.y = (PuntReferencia.y + (posicio.y * Zoom));
    
    //si les dimensions son mes grans de 1 pixel, simprimeix, sino, s'imprimira com a 1.
    if ( PARTICULA_AMPLADA * Zoom > 1 ){  
	ImatgeParticula.w = PARTICULA_AMPLADA * Zoom;
	ImatgeParticula.h = PARTICULA_ALTURA * Zoom;
    }
    else
    {
	ImatgeParticula.w = 1;
	ImatgeParticula.h = 1;
    }
    SDL_FillRect( pantalla, &ImatgeParticula, SDL_MapRGB( pantalla->format, 255, 255, 255 ));
    
}

