// Llibreria per a funcions de vectors
#include <math.h>

using namespace std;
int GExp = -11;
double G = 6.6742* pow(10, GExp); // constant de gravitacio
//funcions vectors

//Creem el nostre propi vector
struct vector {
    double x;
    double y;
};

//funcio per sumar vectors
void SumaVectors( vector& v1, vector v2)
{
    v1.x += v2.x;
    v1.y += v2.y;
}

//restar vectors
void RestaVectors( vector& v1, vector v2)
{
    v1.x -= v2.x;
    v1.y -= v2.y;
}

//multiplicacio vector per escalar
vector MultiplicacioVectors( vector v1, double k )
{
    vector v2;
    v2.x = v1.x*k;
    v2.y = v1.y*k;

    return v2;
}

//divisio entre vector i escalar
vector DivisioVectors( vector v1, long k )
{
    vector v2;
    v2.x = v1.x/ k;
    v2.y = v1.y/ k;
    return v2;
}

//funcio calcular distància
vector DistanciaVectors( vector v1, vector v2)
{
    vector v3;
    
    v3.x = v2.x - v1.x;
    v3.y = v2.y - v1.y;
    return v3;
}

//funcio calcular modul vector
double ModulVector(vector v)
{

    return sqrt( (v.x*v.x) + (v.y*v.y));

}

//funcio calcular vector unitari
vector VectorUnitari ( vector v )
{
    vector vunitari; //vector unitari
    vunitari.x = v.x / ModulVector(v);
    vunitari.y = v.y / ModulVector(v);
    
    return vunitari;
}

// funcio per calcular la força i retornarla en un vector
vector AtraccioVectors ( vector v1, vector v2, unsigned long long m )
{
    vector v3; //vector de la atracco
    vector vdistancia = DistanciaVectors( v1, v2 ); //guardem el vector de la distancia en un vector apart
    double distancia = ModulVector( vdistancia ); // guardem la distancia en un float, per ser mes accessible
    v3.x = (( G * m ) / ( distancia * distancia ) ) * VectorUnitari( vdistancia ).x; //guardem la component x de la atraccio
    v3.y = (( G * m ) / ( distancia * distancia )) * VectorUnitari( vdistancia ).y;
    return v3;
    
}
    