#include <iostream>
#include <SDL/SDL.h>
#include <sstream>
#include <fstream>
#include "llibreriavector.hpp"


using namespace std;

int PANTALLA_AMPLADA;
int PANTALLA_ALTURA;
const int PANTALLA_BPP = 8;
int CICLES_PER_SEGON, FPS;
int NUMERO_PARTICULES, INTRODUIR_PARTICULES;

bool repulsio = false, DibuixarTrajectoria = true; // per si es repeleix o no

int FactorVelocitat = 1;

string EstatVelocitat = "1s = 1s";

float TempsPerCicle, TempsMilisegons, Zoom = 0.5;

vector PuntReferencia;


//superficies a utilitzar
SDL_Surface *pantalla = NULL;

//Estructura del event
SDL_Event event;

#include "llibreriaparticula.hpp"
//funció per iniciar SDL
 bool iniciar()
 {
     //Sinicia tots els subsistemes SDL
     if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
     {
	 cerr << "No s'ha pogut iniciar SDL" << endl;
	 return false;
     }
   
     //parametres de la pantalla
     pantalla = SDL_SetVideoMode( PANTALLA_AMPLADA, PANTALLA_ALTURA, PANTALLA_BPP, SDL_SWSURFACE );
     
     if ( pantalla == NULL )
     {
	 cerr << "Error en ajustar parametres de la pantalla" << endl;
	 return false;
     }

     //ajustar titol finestre
     SDL_WM_SetCaption( "Programa de particules", NULL );
     
     //si tot sha iniciat be
     return true;
 }
 

void netejar()
{
	//Free the surfaces
 	SDL_FreeSurface( pantalla );

	//sortir de SDL
	SDL_Quit();
}
    
//es crea la classe particula desde la llibreria

   
//ctronometre per a calcular els fps   
class Cronometre {
    private:
	int tempsInici;
	int tempsActual;
    public:
	
	Cronometre();
	
	void iniciar();
	
	int temps();
	
};

Cronometre::Cronometre()
{
    //temps inicial es 0
    tempsInici = 0;
}

void Cronometre::iniciar()
{
    // al iniciar, s'agafa el temps d'aquell precis moment
    tempsInici = SDL_GetTicks();
}
int Cronometre::temps()
{
    //pel temps actual, s'agafa el temps actual, menys el temps en que es va iniciar
    tempsActual = SDL_GetTicks() - tempsInici;
    return tempsActual;
}
		
//**********************************
//*******PROGRAMA PRINCIPAl*********
//**********************************
int main( int argc, char* args[] )
{
    //boolea per sortir
    bool sortir = false;
	
    //ints per als fps i frequencia
    int frames = 0, FrequenciaMitjana = 0, FPSMitjana = 0, ContadorFPS = 0;

    //fps per si es capturen els fps o no
    bool cap = true;

     //es creen 3 cronometres
    Cronometre fps, contador, frequencia;

	    //inici obrir arxiu i llegir
	ifstream arxiu ( "config.txt" );
	if ( !arxiu )
	{
	    cerr << "no es pot llegir l'arxiu" << endl;
	}
	else
	{
	    arxiu >> PANTALLA_AMPLADA; //amplada de la finestra
	    arxiu >> PANTALLA_ALTURA; //altura de la finestra
	    arxiu >> NUMERO_PARTICULES; // Numero de particules
	    arxiu >> CICLES_PER_SEGON; // Frequencia
	    arxiu >> FPS; //Fotogrames per segon
	    arxiu >> GExp; // Constant G
	    //Simprimeixen les dades
	    cout << "Pantalla X: " << PANTALLA_AMPLADA << " Pantalla Y: " << PANTALLA_ALTURA << " N particules: " << NUMERO_PARTICULES << " Cicles: " << CICLES_PER_SEGON << " FPS: " << FPS << endl;
	}
	
	if ( NUMERO_PARTICULES <= 0 )
	{
	    cerr << "Número de partícules invàlid" << endl;
	    return 1;
	}
	G = 6.7* pow(10, GExp); // constant de gravitacio
	
// 	Creacio de les particules
//     es crea un vector de particules tan gran con el número de particules
	Particula particula[NUMERO_PARTICULES];
    
	//modificacio dels valors de les particules
	    for (int i = 0; i < NUMERO_PARTICULES; ++i )
	    {
		double posx, posy, velx, vely;
		unsigned long long massa;
		float diametre;
		string restes;
		arxiu >> posx >> restes;
		arxiu >> posy >> restes;
		arxiu >> velx >> restes;
		arxiu >> vely >> restes;
		arxiu >> massa >> restes;
		arxiu >> diametre >> restes;
		//simprimeixen els valors de cada una
		cout << i 
		<< ": Pos X: " << posx 
		<< " | Pos Y: " << posy 
		<< " | Vel X: " << velx
		<< " | Vel Y: "  << vely
		<< " | Massa: "	<< massa
		<< " | Diametre: "<< diametre
		<< endl;
		particula[i].valors( posx, posy, velx, vely, massa, diametre );
	    }
	

    arxiu.close();
    
        
    //PuntReferencia al centre per defecte
    PuntReferencia.x = PANTALLA_AMPLADA/2;
    PuntReferencia.y = PANTALLA_ALTURA/2;
    
        
    //Es carga tot
    if (iniciar() == false)
    {
	cerr << "Error al iniciar" << endl;
	return 1;
    }
    
    
    //inici fps
    contador.iniciar();
    frequencia.iniciar();
    
    //***********************
    //****BUCLE PRINCIPAL****
    //***********************
    
    while( sortir == false)
    {
	//es reinicia fps cada vegada
	frequencia.iniciar();
	
	
	//mentre es recullen els moviments
	while( SDL_PollEvent( &event ) )
	{
	    
	    // --- ENTRADA ---
	    //entrada per a cada particula
	    for (int i = 0; i < NUMERO_PARTICULES; ++i)
	    {
		particula[i].entrada();
	    }
	    
	    //si es prem...
	    if( event.type == SDL_KEYDOWN )
            {
		switch( event.key.keysym.sym )
		{
		    //activar / desactivar captura fps
		    case SDLK_RETURN: cap = ( !cap ); break;

		    //per sortir
		    case SDLK_q: sortir = 1;
		    
		    //activar repulsio
		    case SDLK_r: if (repulsio == true) repulsio = false; else repulsio = true; break;
		    
		    //dibuixar trajectoria
		    case SDLK_t: if (DibuixarTrajectoria == true) DibuixarTrajectoria = false; else DibuixarTrajectoria = true; break;
		    
		    //moure el punt de referencia
		    case SDLK_UP: PuntReferencia.y += 50, DibuixarTrajectoria = false; break;
		    case SDLK_DOWN: PuntReferencia.y -= 50, DibuixarTrajectoria = false; break;
		    case SDLK_LEFT: PuntReferencia.x += 50, DibuixarTrajectoria = false; break;
		    case SDLK_RIGHT: PuntReferencia.x -= 50, DibuixarTrajectoria = false; break;
		    
		    //canvis de velocitat
		    case SDLK_1: FactorVelocitat = 1, EstatVelocitat = "1s = 1s"; break;
		    case SDLK_2: FactorVelocitat = 3600, EstatVelocitat = "1s = 1 hora"; break;
		    case SDLK_3: FactorVelocitat = 86400, EstatVelocitat = "1s = 1 dia"; break;
		    case SDLK_4: FactorVelocitat = 1296000, EstatVelocitat = "1s = 15 dies"; break;
		    case SDLK_5: FactorVelocitat = 2628000, EstatVelocitat = "1s = 1 mes"; break;
		    case SDLK_6: FactorVelocitat = 15768000, EstatVelocitat = "1s = mig any"; break;
		    case SDLK_7: FactorVelocitat = 31536000, EstatVelocitat = "1s = 1 any"; break;
		}
            }

		    
		  
            //si es prem la creu, es surt
	    else if( event.type == SDL_QUIT )
	    {
		sortir = 1;
	    }
	    
	    //event del ratoli
	    if( event.type = SDL_MOUSEBUTTONDOWN )
	    {
		switch( event.button.button )
		{
		    //augmentar/disminuir zoom amb la roda del ratoli
		    case SDL_BUTTON_WHEELUP: Zoom += 0.01, DibuixarTrajectoria = false; break;
		    case SDL_BUTTON_WHEELDOWN: if( Zoom > 0.05 ) Zoom -= 0.01, DibuixarTrajectoria = false; break;
		}
	    }

	}
	
	//**************
	//***MOVIMENT***
	//**************	
	
	//Per a totes les particules
	for (int i = 0; i < NUMERO_PARTICULES; ++i)
	{
	    //moviment independent de cada particula
	    particula[i].moviment();
	    
	    //Per a cada particula, atraccio amb la resta de particules
	    for (int j = 0; j < NUMERO_PARTICULES; ++j)
	    {
		if ( j != i ) //que no coincideixi amb ella  mateixa
		{
		    particula[i].atraccio( particula[j].retornarposicio() , particula[j].retornarmassa() );
		}
	    }
	
	}
    
	//*********************
	//******IMPRIMIR*******
	//*********************
	
	//s'imprimeix amb el limit de FPS
	if ( fps.temps() >= ( 1000 / (FPS) ) )
	{ 
	    
	    //si no es dibuixa la trajectoria, pintar la pantalla.
	    if (DibuixarTrajectoria == false)
	    {	    
		SDL_FillRect( pantalla, &pantalla->clip_rect, SDL_MapRGB( pantalla->format, 0, 0, 0 ) );
	    }
	    
	    //s'imprimeix cada particula
	    for (int i = 0; i < NUMERO_PARTICULES; ++i)
	    {
		particula[i].imprimir( PuntReferencia, Zoom);

	    }
	
	    //s'actualitza la pantalla
	    if( SDL_Flip( pantalla ) == -1 )
	    {
		cerr << "imposible fer flip screen" << endl;
		return 1;
	    }
	    
	   fps.iniciar(); // reiniciar contador fps
	    ++ContadorFPS; // sumar 1 al contador dels fps
	}




	//imprimir totes les dades
	stringstream dades;
	dades << "Programa de Particules per Albert Martinez | Hz: " << FrequenciaMitjana 
	<< " |  FPS: " << FPSMitjana
	<< " |  Zoom: " << Zoom	
	<< " |  V x" << FactorVelocitat
	<< "  | " << EstatVelocitat;

	SDL_WM_SetCaption( dades.str().c_str(), NULL );
	
	
	//*******************
	//***CONTROL FLUX****
	//*******************
	
	//es suma un frame
	++frames;
	
	//reiniciar el contador a cada segon
	if( contador.temps() >= 1000 )
	{	    	    
	    FrequenciaMitjana = frames;
	    FPSMitjana = ContadorFPS;
	    contador.iniciar();
	    frames = 0;
	    ContadorFPS = 0;
	    
	}
	//limitar FPS
	if( (cap == true) and ( frequencia.temps() < 1000 / (CICLES_PER_SEGON)  ))
	{
	    SDL_Delay( ( 1000 / (CICLES_PER_SEGON)) - frequencia.temps() );
	}
	
	
	//temps que passa entre cada cicle
	TempsPerCicle = frequencia.temps() / 1000.f;

    }
    
    
    //es neteja
    netejar();
    
    //fi programa
    return 0;   
}